/*
	Copyright 2008 Amaury GRAILLAT
	Mail: amoweb26@laposte.net
	Jabber: amoweb@im.apinc.org
	WebSite: amoweb.olympe-network.com

	This file is part of KeyBoard SpeedTest.

	KeyBoard SpeedTest is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	KeyBoard SpeedTest is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with KeyBoard SpeedTest.  If not, see <http://www.gnu.org/licenses/>.

*/

#include <QThread>
#include "myThread.h"
#include <iostream>

//Under windows
#ifdef _WIN32
#include <windows.h>
#endif

using namespace std;

extern bool playing;
extern bool editReadOnly;

void MyThread::defineTime( int duration )
{
	cout << __FILE__ << " : void MyThread::defineTime( int duration )" << endl;
	timeCount = duration;
}

void MyThread::run()
{
	cout << __FILE__ << " : void MyThread::run()" << endl;

	while(true)
	{
		while(playing)
		{
			// Update the QLCD:
			emit tic(timeCount);

			#ifdef _WIN32
				Sleep(1000);
			#else
				sleep(1);
			#endif

			if(timeCount <= 0)
			{
				editReadOnly = 1;
				playing = 0;
				
				#ifdef _WIN32
					Sleep(100);
				#else
					sleep(1);
				#endif

				playing=0;

				// Displays the scores:
				emit signalGameTimeout();
			}

			timeCount--;

		}
		
		#ifdef _WIN32
			Sleep(100);
		#else
			sleep(1);
		#endif
	}

}
