/*
	Copyright 2008 Amaury GRAILLAT
	Mail: amoweb26@laposte.net
	Jabber: amoweb@im.apinc.org
	WebSite: amoweb.olympe-network.com

	This file is part of KeyBoard SpeedTest.

	KeyBoard SpeedTest is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	KeyBoard SpeedTest is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with KeyBoard SpeedTest.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef MYQTAPP_H
#define MYQTAPP_H

#include "ui_speedTest.h"
#include "myThread.h"

extern int timeCount;
extern bool playing;

class speedTest : public QWidget, private Ui::speedTestDLG
{
	Q_OBJECT

public:
	speedTest(QWidget *parent = 0);
	//~speedTest;

	//Variables:
	bool randomWord;
	bool userText;

	//Present scores
	long correct;
	long correctChar;
	long wrongChar;
	long wrong;
	
	//Better score:
	long betterCorrectChar;
	long betterCorrect;
	long betterWrong;

	//worst score:
	long worstCorrectChar;
	long worstCorrect;
	long worstWrong;

	//average score:
	long averageCorrect;
	long averageCorrectChar;
	long averageWrong;

	long totalDuration;
	long totalCorrect;
	long totalWrong;

	//Original Text:
	QString originalText;
	QString userOriginalText;
	QString backupText;

	Qt::CaseSensitivity caseSensitive;
	
	//Objects:
	QTimer  *timer;

private:
	//Thread who counts the time:
	MyThread thread;
      
	//Mix the text:
	QString mix( QString string );

signals:
	//Signal to the thread reinitializing the time:
	void reinitTimer(int duration);

public slots:
	//Check the word the user types:
	void checkWord(const QString &edit);

	//User changes the game mode:
	void modeChanged();
	
	//Time Out !
        void gameTimeout();

	//Displays the text, update screen...
	QString word( );
	
	//Updates QLcd, and other widget during the game:
	void tac(int time);

	void about();
};


#endif
